/*
 * Copyright (C) 2002-2003 Stefan Stiller
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package com.kiwisoft.scrap;

import java.io.PrintWriter;

/**
 * @author Stefan Stiller
 * @version $Revision: 1.2 $, $Date: 2004/10/18 18:43:49 $
 */
public abstract class ScrapBase
{
	public abstract ScrapResult $scrap(PrintWriter out) throws Throwable;

	public ScrapResult $result(byte value)
	{
		return new ScrapResult(new Byte(value), Byte.TYPE);
	}

	public ScrapResult $result(short value)
	{
		return new ScrapResult(new Short(value), Short.TYPE);
	}

	public ScrapResult $result(int value)
	{
		return new ScrapResult(new Integer(value), Integer.TYPE);
	}

	public ScrapResult $result(long value)
	{
		return new ScrapResult(new Long(value), Long.TYPE);
	}

	public ScrapResult $result(float value)
	{
		return new ScrapResult(new Float(value), Float.TYPE);
	}

	public ScrapResult $result(double value)
	{
		return new ScrapResult(new Double(value), Double.TYPE);
	}

	public ScrapResult $result(char value)
	{
		return new ScrapResult(new Character(value), Character.TYPE);
	}

	public ScrapResult $result(boolean value)
	{
		return new ScrapResult(new Boolean(value), Boolean.TYPE);
	}

	public ScrapResult $result(Object value)
	{
		if (value==null) return new ScrapResult(null, null);
		else return new ScrapResult(value, value.getClass());
	}
}
