/*
 * Copyright (C) 2002-2003 Stefan Stiller
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package com.kiwisoft.scrap;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import com.kiwisoft.utils.StringUtils;

/**
 * @author Stefan Stiller
 * @version $Revision: 1.2 $, $Date: 2004/10/19 19:20:29 $
 */
public class ScrapTemplate
{
	private static ScrapTemplate instance;

	public static final String CLASS_NAME="$Test";

	public static ScrapTemplate getInstance() throws IOException
	{
		if (instance==null) instance=new ScrapTemplate();
		return instance;
	}

	private String template;

	private ScrapTemplate() throws IOException
	{
		InputStream stream=getClass().getResourceAsStream(CLASS_NAME+".template");
		BufferedReader reader=new BufferedReader(new InputStreamReader(stream));
		StringBuffer buffer=new StringBuffer(187);
		String line;
		while ((line=reader.readLine())!=null) buffer.append(line);
		template=buffer.toString();
	}

	public String buildClass(String[] mainImports, String[] imports, String source)
	{
		String sourceCode=template;
		StringBuffer importBuffer=new StringBuffer();
		if (mainImports!=null)
			for (int i=0; i<mainImports.length; i++) importBuffer.append("import "+mainImports[i]+";\n");
		if (imports!=null)
			for (int i=0; i<imports.length; i++) importBuffer.append("import "+imports[i]+";\n");
		sourceCode=StringUtils.replaceStrings(sourceCode, "/*imports*/", importBuffer.toString());
		sourceCode=StringUtils.replaceStrings(sourceCode, "/*code*/", source);
		return sourceCode;
	}

}
